Subject: bug#47360: 27.1; using 'bar cursor, mouseclick is rounded to the wrong char position

From: Eli Zaretskii <[email-masked]>
Date: Wed, 24 Mar 2021 19:25:03 +0200

> Date: Wed, 24 Mar 2021 07:42:28 +0000
> From:  Julian Rohrhuber via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> When using 'bar as cursor, the click location is truncated to the value before the character one clicks on (as expected when using a 'box). When using a 'bar, however, one expects that the "hill" is in the center of each character, and the valley between them. I've made an illustration, where the green color shows the watershed, so to speak.
> 
> This behavior feels subtly broken.
> 
> A solution to the issue has been suggested https://emacs.stackexchange.com/questions/20279/mouse-pointer-between-characters-and-the-text-cursor-misplacement
> 
> Using the modified function posn-set-point below fixes the issue for me. I find the behavior also reasonable for 'box, but that might be a matter of discussion.

I don't think I see the problem you describe.  If I click exactly on
the bar cursor, the cursor doesn't move, as I'd expect.

In any case, please note that in Emacs the bar cursor is never exactly
between two characters, it is at the left side of a character cell, so
closer to the character on the right (for left-to-right text).